src/Entity/User.php
<?php

namespace App\Entity;

use App\Entity\Meeting\Weekend\Program;
use App\Entity\Territory\History;
use App\Repository\UserRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Ramsey\Uuid\Uuid;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Validator\Constraints as Assert;

#[ORM\Table(name: '`user`')]
#[UniqueEntity('email')]
#[ORM\Entity(repositoryClass: UserRepository::class)]
#[ORM\HasLifecycleCallbacks]
class User implements UserInterface, PasswordAuthenticatedUserInterface
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: 'integer')]
    private $id;

    #[Assert\Email(groups: ['create'])]
    #[ORM\Column(type: 'string', length: 180, unique: true)]
    private $email;

    #[ORM\Column(type: 'json')]
    private $roles = [];

    /**
     * @var string The hashed password
     */
    #[Assert\Regex('/^(?=.*[0-9])(?=.*[a-zA-Z])([a-zA-Z0-9]+)(?=.*[#$@\-!%_&*?§=}]).{8,255}$/', message: 'Le mot de passe doit contenir 8 caractères minimum, dont au moins 1 caractère spécial et 1 chiffre', groups: ['reset'])]
    #[ORM\Column(type: 'string')]
    private $password;

    #[Assert\NotBlank(groups: ['create'])]
    #[ORM\Column(type: 'string', length: 128)]
    private $firstName;

    #[Assert\NotBlank(groups: ['create'])]
    #[ORM\Column(type: 'string', length: 128)]
    private $lastName;

    #[ORM\Column(type: 'boolean')]
    private $isActive = false;

    #[ORM\Column(type: 'datetime_immutable', nullable: true)]
    private $deletedAt;

    #[ORM\Column(type: 'datetime_immutable')]
    private $createdAt;

    #[ORM\Column(type: 'datetime_immutable', nullable: true)]
    private $updatedAt;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $token;

    #[ORM\OneToOne(inversedBy: 'user', targetEntity: Publisher::class, cascade: ['persist', 'remove'])]
    private $publisher;

    #[ORM\OneToMany(mappedBy: 'createdBy', targetEntity: Program::class)]
    private $programs;

    #[ORM\OneToMany(mappedBy: 'createdBy', targetEntity: History::class)]
    private $territoryHistories;

    public function __construct()
    {
        $this->programs = new ArrayCollection();
        $this->territoryHistories = new ArrayCollection();
    }


    public function getId(): ?int
    {
        return $this->id;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    /**
     * A visual identifier that represents this user.
     *
     * @see UserInterface
     */
    public function getUserIdentifier(): string
    {
        return (string) $this->email;
    }

    /**
     * @deprecated since Symfony 5.3, use getUserIdentifier instead
     */
    public function getUsername(): string
    {
        return (string) $this->email;
    }

    /**
     * @see UserInterface
     */
    public function getRoles(): array
    {
        $roles = $this->roles;
        // guarantee every user at least has ROLE_USER
        $roles[] = 'ROLE_USER';

        return array_unique($roles);
    }

    public function setRoles(array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    /**
     * @see PasswordAuthenticatedUserInterface
     */
    public function getPassword(): string
    {
        return $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }

    /**
     * Returning a salt is only needed, if you are not using a modern
     * hashing algorithm (e.g. bcrypt or sodium) in your security.yaml.
     *
     * @see UserInterface
     */
    public function getSalt(): ?string
    {
        return null;
    }

    /**
     * @see UserInterface
     */
    public function eraseCredentials()
    {
        // If you store any temporary, sensitive data on the user, clear it here
        // $this->plainPassword = null;
    }

    public function getFirstName(): ?string
    {
        return $this->firstName;
    }

    public function setFirstName(string $firstName): self
    {
        $this->firstName = $firstName;

        return $this;
    }

    public function getLastName(): ?string
    {
        return $this->lastName;
    }

    public function setLastName(string $lastName): self
    {
        $this->lastName = $lastName;

        return $this;
    }

    public function isActive(): ?bool
    {
        return $this->isActive;
    }

    public function setIsActive(bool $isActive): self
    {
        $this->isActive = $isActive;

        return $this;
    }

    public function getDeletedAt(): ?\DateTimeImmutable
    {
        return $this->deletedAt;
    }

    public function setDeletedAt(?\DateTimeImmutable $deletedAt): self
    {
        $this->deletedAt = $deletedAt;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeImmutable
    {
        return $this->createdAt;
    }

    public function setCreatedAt(\DateTimeImmutable $createdAt): self
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    public function getUpdatedAt(): ?\DateTimeImmutable
    {
        return $this->updatedAt;
    }

    public function setUpdatedAt(?\DateTimeImmutable $updatedAt): self
    {
        $this->updatedAt = $updatedAt;

        return $this;
    }

    #[ORM\PrePersist]
    public function setCreadtedAtValue(): void
    {
        $this->createdAt = new \DateTimeImmutable();
    }

    #[ORM\PreUpdate]
    public function setUpdatedAtValue(): void
    {
        $this->updatedAt = new \DateTimeImmutable();
    }

    public function getFullName(): string
    {
        return $this->firstName . ' ' . $this->lastName;
    }

    public function getToken(): ?string
    {
        return $this->token;
    }

    public function setToken(?string $token): self
    {
        $this->token = $token;

        return $this;
    }

    #[ORM\PrePersist]
    public function setTokenValue(): void
    {
        $this->token = Uuid::uuid4()->toString();
    }

    public function getPublisher(): ?Publisher
    {
        return $this->publisher;
    }

    public function setPublisher(?Publisher $publisher): self
    {
        $this->publisher = $publisher;

        return $this;
    }

    /**
     * @return Collection<int, Program>
     */
    public function getPrograms(): Collection
    {
        return $this->programs;
    }

    public function addProgram(Program $program): self
    {
        if (!$this->programs->contains($program)) {
            $this->programs[] = $program;
            $program->setCreatedBy($this);
        }

        return $this;
    }

    public function removeProgram(Program $program): self
    {
        if ($this->programs->removeElement($program)) {
            // set the owning side to null (unless already changed)
            if ($program->getCreatedBy() === $this) {
                $program->setCreatedBy(null);
            }
        }

        return $this;
    }

    public function isIsActive(): ?bool
    {
        return $this->isActive;
    }

  public function getTerritoryHistories(): Collection
  {
    return $this->territoryHistories;
  }

}

src/Form/Meeting/Weekend/EditWishlistType.php
<?php

namespace App\Form\Meeting\Weekend;

use App\Entity\Meeting\Weekend\Speech;
use App\Entity\Meeting\Weekend\Wishlist;
use App\Entity\Publisher;
use App\Repository\PublisherRepository;
use Doctrine\ORM\EntityRepository;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class EditWishlistType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('speeches', EntityType::class, [
                'class' => Speech::class,
                'multiple' => true,
                'choice_label' => 'number',
                'attr' => [
                    'class' => 'js-select2',
                    'data-search' => 'on'
                ],
                'by_reference' => true,
                'label' => 'Thème(s)'

            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Wishlist::class
        ]);
    }
}

src/Form/Meeting/Weekend/SpeechCategoryType.php
<?php

namespace App\Form\Meeting\Weekend;

use App\Entity\Meeting\Weekend\SpeechCategory;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class SpeechCategoryType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('title')
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => SpeechCategory::class,
        ]);
    }
}

src/Controller/Meeting/Weekend/ProgramController.php
<?php

namespace App\Controller\Meeting\Weekend;
use App\Entity\Meeting\Weekend\Program;
use App\Form\Meeting\Weekend\ProgramType;
use App\Repository\Meeting\Weekend\ProgramRepository;
use App\Service\Meeting\Weekend\ProgramService;
use Knp\Bundle\SnappyBundle\Snappy\Response\PdfResponse;
use Knp\Snappy\Pdf;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use function Sodium\add;

#[Route(path: '/meeting/weekend/programs')]
class ProgramController extends AbstractController
{

    private ProgramService $service;

    public function __construct(ProgramService $service)
    {
        $this->service = $service;
    }


    #[Route(path: '/create/{month}/{year}', name: 'app_meeting_weekend_program_create')]
    public function create(Request $request, int $month, int $year)
    {
        $program = $this->service->prepareCreate($month, $year);
        $form = $this->createForm(ProgramType::class, $program);
        $form->handleRequest($request);

        if($form->isSubmitted() && !$program->isIsDraft() && $form->isValid()) {
            $this->service->createOrUpdate($program, $this->getUser());
            $this->addFlash('success','Programme enregistré');
            return $this->redirectToRoute('app_meeting_weekend_program_show', ['id' => $program->getId()]);
        }
        if ($form->isSubmitted() && $program->isIsDraft()) {
            $this->service->createOrUpdate($program, $this->getUser());
            $this->addFlash('success','Programme enregistré en tant que brouillon');
            return $this->redirectToRoute('app_meeting_weekend_program_show', ['id' => $program->getId()]);
        }
        return $this->render('meeting/weekend/program/create.html.twig', [
            'program' => $program,
            'form' => $form->createView(),
            'path' => $request->getUri()
        ]);
    }

    #[Route(path: '/edit/{id}', name: 'app_meeting_weekend_program_edit')]
    public function edit(Program $program, Request $request)
    {
        $form = $this->createForm(ProgramType::class, $program);
        $form->handleRequest($request);

        if($form->isSubmitted() && !$program->isIsDraft() && $form->isValid()) {
            $this->service->createOrUpdate($program);
            $this->addFlash('success','Programme modifié');
            return $this->redirectToRoute('app_meeting_weekend_program_show', ['id' => $program->getId()]);
        }
        if ($form->isSubmitted() && $program->isIsDraft()) {
            $this->service->createOrUpdate($program);
            $this->addFlash('success','Programme enregistré en tant que brouillon');
            return $this->redirectToRoute('app_meeting_weekend_program_show', ['id' => $program->getId()]);
        }
        return $this->render('meeting/weekend/program/create.html.twig', [
            'program' => $program,
            'form' => $form->createView(),
            'path' => $request->getUri()
        ]);
    }

    #[Route(path: '/list/{year}', name: 'app_meeting_weekend_program_list')]
    public function list(ProgramRepository $repository, int $year): Response
    {
        return $this->render('meeting/weekend/program/list.html.twig', [
            'programs' => $repository->findAllByYear($year)
        ]);

    }

    #[Route(path: '/show/{id}', name: 'app_meeting_weekend_program_show')]
    public function show(Program $program)
    {
        return $this->render('meeting/weekend/program/show.html.twig', [
            'program' => $program
        ]);
    }

    #[Route(path: '/delete/{id}', name: 'app_meeting_weekend_program_delete')]
    public function delete(Program $program, ProgramRepository $repository)
    {
        $year = $program->getStartDate()->format('Y');
        $repository->remove($program, true);
        $this->addFlash('success', 'Programme supprimé');
        return $this->redirectToRoute('app_meeting_weekend_program_list', ['year' => $year]);
    }

    #[Route(path: '/export/{id}', name: 'app_meeting_weekend_program_export')]
    public function exportPdf(Program $program, Pdf $pdf)
    {
        $html = $this->renderView('pdf/program_weekend.html.twig', array(
            'program'  => $program
        ));

        return new PdfResponse(
            $pdf->getOutputFromHtml($html),
            $program->getStartDate()->format('F Y') . '.pdf'
        );
    }

}

src/Controller/Meeting/Weekend/SpeechSurveyController.php
<?php

namespace App\Controller\Meeting\Weekend;

use App\Entity\Meeting\Weekend\SpeechSurvey;
use App\Entity\Publisher;
use App\Form\Meeting\Weekend\SpeechSurveyType;
use App\Repository\AssignmentRepository;
use App\Repository\Meeting\SpeechSurveyRepository;
use App\Repository\Meeting\Weekend\SpeechRepository;
use App\Repository\PublisherRepository;
use Doctrine\ORM\EntityManagerInterface;
use Ramsey\Uuid\Uuid;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
use Symfony\Component\Routing\Attribute\Route;

#[Route('/meeting/weekend/speech/surveys')]
class SpeechSurveyController extends AbstractController
{

  public function __construct(
    private readonly SpeechSurveyRepository $repository,
    private readonly EntityManagerInterface $em
  ){}

  #[Route('/add/{token}', name: 'app_meeting_weekend_speech_survey_add')]
  public function addOrUpdate(?string $token, Request $request): Response
  {
      $survey = $this->repository->findOneBy(['token' => $token]);
      if (!$survey) {
        throw new NotFoundHttpException("Le formulaire n'a pas été trouvé");
      }
      $form = $this->createForm(SpeechSurveyType::class, $survey);
      $form->handleRequest($request);
      if ($form->isSubmitted() && $form->isValid()) {
        $this->em->persist($survey);
        $this->em->flush();
        $this->addFlash('success', "Le formulaire a été transmis avec succès. Merci pour ta participation.");
        return $this->redirectToRoute("app_meeting_weekend_speech_survey_add", ['token' => $token]);
      }
      return $this->render('meeting/weekend/speech_survey/add.html.twig', [
          'form' => $form->createView(),
          'speaker' => $survey->getSpeaker()
      ]);
  }

  #[Route('/generate/{idPublisher}', name: 'app_meeting_weekend_speech_survey_generate')]
  public function generate(Publisher $idPublisher): RedirectResponse
  {
    $token = Uuid::uuid4();
    $survey = new SpeechSurvey();
    $survey->setToken($token)
      ->setSpeaker($idPublisher)
      ;
    $survey->setYear(2025);
    $this->em->persist($survey);
    $this->em->flush();

    $this->addFlash('success', "Le formulaire pour " . $idPublisher->getFullName() . " a été généré");
    return $this->redirectToRoute('app_meeting_weekend_speech_survey_list', ['year' => 2025]);
  }

  #[Route('/{year}', name: 'app_meeting_weekend_speech_survey_list')]
  public function list(int $year, PublisherRepository $publisherRepository): Response
  {
    $speakers = $publisherRepository->findAllSpeakersForSurveyGeneration();
    return $this->render('meeting/weekend/speech_survey/list.html.twig', [
      'surveys' => $this->repository->findAllForList($year),
      'speakers' => $speakers
    ]);
  }

  #[Route('/resume')]
  public function resume(SpeechRepository $speechRepository, Request $request, PublisherRepository $publisherRepository): Response
  {
    $speakers = $publisherRepository->findAllForAssignment(true);
    $speeches = $speechRepository->findPicked();
    $publisherId = $request->query->get('publisherId');
    if ($publisherId) {
      $publisher = $publisherRepository->find($publisherId);
      $surveys = $publisher->getSpeechSurveys();
      if ($surveys->count() > 0) {
        $speeches = $surveys->get(0)->getSpeeches();
      } else {
        $speeches = [];
      }
    }
    return $this->render('meeting/weekend/speech_survey/resume.html.twig', [
      'speeches' => $speeches,
      'speakers' => $speakers
    ]);
  }


}

templates/meeting/wishlist/create.html.twig
{% extends 'base.html.twig' %}
{% block header_title %}Base de travail orateurs{% endblock %}
{% block header_subtitle %}{% endblock %}

{% block body %}
    <div class="col-xxl-10 col-sm-12 col-md-12">
        {% for message in app.flashes('success') %}
            <div class="alert alert-fill alert-icon alert-success alert-dismissible">
                <em class="icon ni ni-check-circle-fill"></em>
                {{ message }}
            </div>
        {% endfor %}
        <div class="card card-bordered card-full">
            <div class="card-inner">
                <div class="card-title-group">
                    <div class="card-title">
                        <h6 class="title"><span class="me-2">Base de travail orateurs</span></h6>
                    </div>
                </div>
            </div>
            <div class="card-inner border-top">
                <form action="{{ path('app_meeting_weekend_wishlist_create') }}" method="post" id="createWishlistForm">
                    <div class="row gy-4">
                        <div class="col-sm-6">
                            <div class="form-group">
                                {{ form_label(form.publisher) }}
                                <div class="form-control-wrap">
                                    {{ form_widget(form.publisher) }}
                                    {{ form_errors(form.publisher) }}
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-6 mt-2">
                            <div class="form-group">
                                {{ form_label(form.speeches) }}
                                <div class="form-control-wrap">
                                    {{ form_widget(form.speeches) }}
                                    {{ form_errors(form.speeches) }}
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mt-4">
                        <button class="btn btn-success" type="submit"><em class="icon ni ni-save-fill me-1"></em> Enregistrer</button>
                        <button id="createNext" class="btn btn-primary" type="submit"><em class="icon ni ni-property-add me-1"></em> Enregistrer et ajouter une nouvelle liste</button>
                    </div>
                    {{ form_widget(form._token) }}
                </form>
            </div>
        </div><!-- .card -->
    </div><!-- .col -->
{% endblock %}
{% block javascripts %}
    <script>
        const $buttonCreateNext = document.getElementById("createNext");
        const $form = document.getElementById("createWishlistForm");
        $buttonCreateNext.addEventListener('click', function () {
            $form.action = $form.action + '?createNext=true';
        })
    </script>
{% endblock %}

templates/meeting/wishlist/edit.html.twig
{% extends 'base.html.twig' %}
{% block header_title %}Base travail orateur{% endblock %}
{% block header_subtitle %}{{ wishlist.publisher.fullName }}{% endblock %}

{% block body %}
    <div class="col-xxl-10 col-sm-12 col-md-12">
        {% for message in app.flashes('success') %}
            <div class="alert alert-fill alert-icon alert-success alert-dismissible">
                <em class="icon ni ni-check-circle-fill"></em>
                {{ message }}
            </div>
        {% endfor %}
        <div class="card card-bordered card-full">
            <div class="card-inner">
                <div class="card-title-group">
                    <div class="card-title">
                        <h6 class="title"><span class="me-2">Base de travail - {{ wishlist.publisher.fullName }}</span></h6>
                    </div>
                </div>
            </div>
            <div class="card-inner border-top">
                <form action="{{ path('app_meeting_weekend_wishlist_edit', {'id' : wishlist.id}) }}" method="post" id="createWishlistForm">
                    <div class="row">
                        <div class="col-sm-6 mt-2">
                            <div class="form-group">
                                {{ form_label(form.speeches) }}
                                <div class="form-control-wrap">
                                    {{ form_widget(form.speeches) }}
                                    {{ form_errors(form.speeches) }}
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mt-4">
                        <button class="btn btn-success" type="submit"><em class="icon ni ni-save-fill me-1"></em> Enregistrer</button>
                        <button id="createNext" class="btn btn-primary" type="submit"><em class="icon ni ni-property-add me-1"></em> Enregistrer et ajouter une nouvelle liste</button>
                    </div>
                    {{ form_widget(form._token) }}
                </form>
            </div>
        </div><!-- .card -->
    </div><!-- .col -->
{% endblock %}
{% block javascripts %}
    <script>
        const $buttonCreateNext = document.getElementById("createNext");
        const $form = document.getElementById("createWishlistForm");
        $buttonCreateNext.addEventListener('click', function () {
            $form.action = $form.action + '?createNext=true';
        })
    </script>
{% endblock %}

templates/meeting/wishlist/list.html.twig
{% extends 'base.html.twig' %}
{% block header_title %}Bases travail orateurs{% endblock %}
{% block header_subtitle %}Liste des orateurs et leurs souhaits de discours{% endblock %}
{% block head_content %}
    <div class="toggle-wrap nk-block-tools-toggle">
        <a href="#" class="btn btn-icon btn-trigger toggle-expand me-n1" data-target="pageMenu"><em class="icon ni ni-more-v"></em></a>
        <div class="toggle-expand-content" data-content="pageMenu">
            <ul class="nk-block-tools g-3">
                <li class="nk-block-tools-opt"><a href="{{ path('app_meeting_weekend_wishlist_create') }}" class="btn btn-primary"><em class="icon ni ni-user-add-fill"></em><span>Ajouter un frère</span></a></li>
            </ul>
        </div>
    </div>
{% endblock %}
{% block body %}
    <div class="col-xxl-12 col-sm-12 col-md-12">
        {% for message in app.flashes('success') %}
            <div class="alert alert-fill alert-icon alert-success alert-dismissible">
                <em class="icon ni ni-check-circle-fill"></em>
                {{ message }}
            </div>
        {% endfor %}
        <div class="card card-bordered card-full">
            <div class="card-inner">
                <div class="card-title-group">
                    <div class="card-title">
                        <h6 class="title"><span class="me-2">Bases de travail orateurs</span></h6>
                    </div>
                </div>
            </div>
            <div class="card-inner p-0 border-top">
                <div class="nk-tb-list nk-tb-orders">
                    <div class="nk-tb-item nk-tb-head">
                        <div class="nk-tb-col tb-col"><span>Nom</span></div>
                        <div class="nk-tb-col tb-col-md"><span>Thèmes</span></div>
                        <div class="nk-tb-col"><span>&nbsp;</span></div>
                    </div>
                    {% for wishlist in wishlists %}
                            <div class="nk-tb-item">
                                <div class="nk-tb-col">
                                    <span><a href="{{ path('app_meeting_weekend_wishlist_edit', {'id': wishlist.id}) }}">{{ wishlist.publisher.fullName }}</a></span>
                                </div>
                                <div class="nk-tb-col tb-col-md">
                                    {% for speech in wishlist.speeches %}
                                        <span class="badge bg-secondary">{{ speech.number }}</span>
                                    {% endfor %}
                                </div>
                                <div class="nk-tb-col nk-tb-col-action">
                                    <div class="dropdown">
                                        <a class="text-soft dropdown-toggle btn btn-icon btn-trigger" data-bs-toggle="dropdown"><em class="icon ni ni-more-h"></em></a>
                                        <div class="dropdown-menu dropdown-menu-end dropdown-menu-xs">
                                            <ul class="link-list-plain">
                                                <li><a href="{{ path('app_meeting_weekend_wishlist_edit', {'id': wishlist.id}) }}">Modifier</a></li>
                                            </ul>
                                        </div>
                                    </div>
                                </div>
                            </div>
                    {% endfor %}
                </div>
            </div>
        </div><!-- .card -->
    </div><!-- .col -->

{% endblock %}